<% 
 java.util.List<com.hello2morrow.sonargraph.core.model.element.Issue> unresolvedIssues = report.unresolvedIssues;
 java.util.List<com.hello2morrow.sonargraph.core.model.resolution.Resolution> resolutions = report.resolutions;
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, 
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
 java.util.Set<com.hello2morrow.sonargraph.core.model.report.MetricRow>>>> metricValueRows = report.getElementMetricsForPrint(maxMetricValueRowCountPerMetric);
 
 boolean isScriptRunnerEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.SCRIPTS_AUTOMATED);
 boolean isDuplicateCodeEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.DUPLICATE_CODE);
 boolean isArchitectureCheckEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.ARCHITECTURE)
 boolean isVirtualModelsEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.VIRTUAL_MODELS);
%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
        <style type="text/css" MEDIA="all">@import url("hello2morrow.css");</style>
        <script src="tablefilter/tablefilter.js"></script>
        <title>Sonargraph Architect Report</title>
    </head>

    <body>
    <script>
    	window.name = "<%=report.getTargetFile().getName()%>";
    </script>
        <a name="top"></a>
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td width="200" bgcolor="#333333"><img src="spacer.gif" alt="" width="200" height="65" border="0"></td>
                <td width="23" bgcolor="E3E4E5"><img src="spacer.gif" width="23" height="1"></td>
                <td width="100%" bgcolor="E3E4E5">
                    <table border="0" cellspacing="0" cellpadding="0">
                        <tr>
                            <td width="7" bgcolor="e3e4e5"><img src="spacer.gif" width="7" height="1"></td>
                            <td><img src="hello2morrow.gif" alt="hello2morrow" width="227" height="23" border="0"></td>
                            <td width="100%" align="right" bgcolor="e3e4e5"><img src="header.gif" alt="hello2morrow" width="543" height="65" border="0"></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="3" bgcolor="#000000"></td>
            </tr>
            <tr>
<!-- start of navigation -->            
                <td bgcolor="#A7A9AC" valign="top">
                    <div class="leftNav">
                        <ul>
                            <li><a href="#system">System</a></li>
                            <li><a href="#automatedScripts">Automated Scripts <% 
                            if (isScriptRunnerEnabled) 
                            { 
                                out.println("(" + report.getAutomatedScriptConfigurations().size() + ")")
                            }%></a></li>
                            <li><a href="#workspace">Workspace</a></li>
                            <li><a href="#openIssues">Unresolved Issues (<%= unresolvedIssues.size() %>)</a></li>
                            <%
                        	if (!splitIssuesSection)
                        	{
                            %>
	                            <li><a href="#cycleGroups">Cycle Groups (<%= report.getNumberOfUnresolvedCycleGroups() %>)</a></li>
	                            <li><a href="#duplicateBlocks">Duplicate Blocks <% 
	                            if (isDuplicateCodeEnabled) 
	                            { 
	                                out.println("(" + report.getUnresolvedDuplicateIssues().size() + ")")
	                            }%></a></li>
                            <%
                            }
                            %>
                            <li><a href="#resolutions">Resolutions <% 
                            if (isVirtualModelsEnabled) 
                            { 
                                out.println("(" + resolutions.size() + ")")
                            }%></a></li>
                            <li><a href="#elementMetrics">Element Level Metrics</a>
                                <ul>
                                    <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, java.util.Map<
                                               com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.MetricRow>>>> entry : metricValueRows.entrySet())
                                    {
                                    %>
                                    <li><a class="secondLevel" href="#elementMetrics_<%=entry.getKey().getStandardName()%>"><%=entry.getKey().getPresentationName()%> Level Metrics</a></li>
                                    <%
                                    }
                                    %>
                                </ul>
                            </li>
                            <li><a href="#metricInfos">Metric Infos</a></li>
                        </ul>
                    </div>
                </td>
<!-- end of navigation -->
                <!-- start of spacer -->
                <td width="23"><img src="spacer.gif" width="23" height="1"></td><!-- end of spacer -->
                
                <!-- real content -->
                <td width="100%">
                    <table width="100%" border="0">
                        <tr>
                            <td width="1%" height="80" valign="center">
                                <image src="logo.gif" width="350"></image>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h1><a name="system"></a>System: <%= report.softwareSystem.name %></h1>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <strong>Path: </strong><%= report.systemDirectoryPath %><br/>
                                <strong>System Description:<%= report.softwareSystem.description %></strong><br/>
                                <strong>Sonargraph Version: </strong><%= report.version %><br/>
                                <strong>Report Creation: </strong><%= report.timestampString %><br/>
                                <strong>Max. Values / Metric: </strong><%= maxMetricValueRowCountPerMetric %><br/>
                                <strong>Current Virtual Model: </strong><%= report.currentVirtualModel %> <br/>
                                <%
                                    if (report.getActiveProfile() != null && report.getActiveProfile().length() > 0)
                                    {
                                %>
                                        <strong>Workspace Profile: </strong><%= report.activeProfile %> <br/>
                                <%
                                    }
                                %>
                                <%
                                    if (report.getQualityModelPath() != null && report.getQualityModelPath().length() > 0)
                                    {
                                %>
                                        <strong>Quality Model: </strong><%= report.qualityModelPath %> <br/>
                                <%
                                    }
                                %>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h2>Licensed Features</h2>
                                <table class="techTable" id="features">
                                    <thead>
	                                    <tr>
	                                        <th width="450">Feature</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                      int i = 0;
                                      for (com.hello2morrow.sonargraph.core.model.common.SonargraphFeature feature : report.getAvailableFeatures())
                                      {
                                        i++;
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(feature.getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                      }
                                    %>
                                </table>
                                <script>
                            		var filtersConfig = {
										base_path: 'tablefilter/',
						        		alternate_rows: true,
						        		grid: false,
									    col_widths: ['450px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('features', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                        <% 
                        if(report.getUnavailableFeatures().size() > 0)
                        { 
                        %> 
                        <tr>
                            <td>
                                <h2>Not Licensed Features</h2>
                                <table class="techTable" id="unlicensedFeatures">
                                    <tr>
                                        <th width="450">Feature</th>
                                    </tr>
                                    <% 
                                      i = 0;
                                      for (com.hello2morrow.sonargraph.core.model.common.SonargraphFeature feature : report.getUnavailableFeatures())
                                      {
                                        i++;
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(feature.getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                      }
                                    %>
                                </table>
                                <script>
                            		var filtersConfig = {
										base_path: 'tablefilter/',
						        		alternate_rows: true,
						        		grid: false,
									    col_widths: ['450px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('unlicensedFeatures', filtersConfig);
									tf.init();
								</script>    
                            </td>
                        </tr>
                        <%
                        }
                        %>
<!-- System Metrics -->                        
                        <tr>
                            <td><h2>System Metrics</h2></td>
                        </tr>
                        <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, com.hello2morrow.sonargraph.core.model.analysis.IMetricValue>> nextCategory : report.getSystemLevelMetrics())
                        {
                        %>
                        <tr>
                            <td><strong>Metric Category: <%= nextCategory.getKey().getPresentationName() %></strong><br/>
                                <table class="techTable" id="system_<%=nextCategory.getKey().getStandardName()%>">
                                	<thead>
	                                    <tr>
	                                        <th>Name</th>
	                                        <th>Value</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                        i = 0;
                                        for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, com.hello2morrow.sonargraph.core.model.analysis.IMetricValue> next : nextCategory.getValue().entrySet())
                                        {
                                            i++;
                                            out.println("<tr>");
                                            out.println("<td>");
                                            out.println(next.getKey().getName());
                                            out.println("</td>");
                                            out.println("<td>");
                                            if (next.getKey().getMetricId().isFloat())
                                            {
                                                out.println(String.format("%.2f", next.getValue().getValue()));
                                            }
                                            else 
                                            {
                                                out.println(next.getValue().getValue());
                                            }
                                            out.println("</td>");
                                            out.println("</tr>");
                                        }
                                    %>
                                </table>
                                <% if (i > 0)
                                {
                                %>
                                <script>
                            		var filtersConfig = {
										base_path: 'tablefilter/',
						        		alternate_rows: true,
						        		grid: false,
									    col_widths: ['450px', '150px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('system_<%=nextCategory.getKey().getStandardName()%>', filtersConfig);
									tf.init();
								</script>  
                                <%}%>
                                <br/>
                            </td>
                        </tr>
                        <%
                        }
                        %>
                        <tr>
                            <td><h2><a name="workspace"></a>Workspace <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <%
                        if (report.getWorkspaceFilters().size() > 0)
                        {
                        %>
                        <tr>
                            <td><strong>Workspace Filter:</strong><br/>
                                <table class="techTable" id="workspaceFilter">
                                    <thead>
	                                    <tr>
	                                        <th>Type</th>
	                                        <th>Pattern</th>
	                                        <th>Info</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.filter.WildcardPattern pattern : report.getWorkspaceFilters())
                                        {
                                        	out.println("<tr>");
                                        	
                                            out.println("<td>");
                                            out.println(pattern.getPresentationKind());
                                            out.println("</td>");
                                            
                                            out.println("<td>");
                                            out.println(pattern.getName());
                                            out.println("</td>");
                                            
                                            out.println("<td>");
                                            out.println(pattern.getInformation());
                                            out.println("</td>");
                                            
                                            out.println("</tr>");
                                            i++;
                                        } 
                                    %>
                                </table>
                                <script>
                            		var filtersConfig = {
										base_path: 'tablefilter/',
						        		alternate_rows: true,
						        		grid: false,
									    col_widths: ['150px', '60%', '250px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('workspaceFilter', filtersConfig);
									tf.init();
								</script>
                                <br/>
                            </td>
                        </tr>
                        <%
                        }
                        %>
                        <tr>
                            <td><strong>Modules:</strong><br/>
                                <table class="techTable" id="workspace" width="100%">
                                	<thead>
		                                <tr>
	                                        <th>Module</th>
	                                        <th>Root Path</th>
	                                        <th>Number of Files</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.workspace.Module module : report.getModules())
                                        {
                                            for (com.hello2morrow.sonargraph.core.model.path.RootDirectoryPath path : module.getChildren(com.hello2morrow.sonargraph.core.model.path.RootDirectoryPath.class))
                                            {
                                                out.println("<tr>");
                                                out.println("<td>");
                                                out.println(module.getName());
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(path.getName());
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(path.getNumberOfFiles());
                                                out.println("</td>");
                                                out.println("</tr>");
                                                i++;
                                            }
                                        }
                                    %>
                                </table>
                                    <%
                                	if (i > 0)
                                	{
                                	%>
                                	<script>
                                		var rowCount = <%=i%>;
                                		var rowCounts = [25, 50];
                                		if (rowCount > 50)
                                		{
                                			rowCounts = [25, 50, rowCount];
                                		}
                                		
                                		var enablePaging = rowCount > 25;
                                		
							    		var filtersConfig = {
											base_path: 'tablefilter/',
							        		extensions:[{
								          		name: 'sort',
								          		types: ['string', 'string', 'number']
							        		}],
											alternate_rows: true,
											rows_counter: true,
							            	rows_counter_text: 'Root Directories: ',
							            	btn_reset: true,
							            	status_bar: true,
							            	loader: true,
											mark_active_columns: true,
											highlight_keywords: true,
											paging: enablePaging,
									        results_per_page: ['Directories/Page: ', rowCounts],
									       	col_widths: ['', '', '150px'],
							        		themes: [{ name: 'default' }]
									    };
										var tf = new TableFilter('workspace', filtersConfig);
										tf.init();
									</script>
                                	<%
                                	}
                                	%>
                            </td>
                        </tr>
                        <tr>
                            <td><h2><a name="automatedScripts"></a>Automated Scripts <% 
                            if (isScriptRunnerEnabled) 
                            { 
                                out.println("(" + report.getAutomatedScriptConfigurations().size() + ")")
                            }%> <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="50%" id="automatedScripts">
                                    <thead>
	                                    <tr>
	                                        <th width="450">Script</th>
	                                        <th width="250">Run Configuration</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.analysis.ScriptRunnerData data : report.getAutomatedScriptConfigurations())
                                        {
                                            i++;
                                            out.println("<tr>");
                                            out.println("<td>");
                                            out.println(data.getIdentifyingScriptPath());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(data.getRunConfigurationName());
                                            out.println("</td>");
                                            out.println("</tr>");
                                        }
                                        
                                        if (i == 0)
                                        {
                                            out.println("<tr>");
                                            if (isScriptRunnerEnabled)
                                            {
                                                out.println("<td>No automated scripts</td><td></td>");
                                            }
                                            else
                                            {
                                                out.println("<td><font color=\"red\">Script runner not licensed</font></td><td></td>");
                                            }
                                        } 
                                    %>
                                </table>
                                <script>
                            		var filtersConfig = {
										base_path: 'tablefilter/',
						        		alternate_rows: true,
						        		grid: false,
									    col_widths: ['450px', '250px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('automatedScripts', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
<!-- All Unresolved Issues -->
                        <tr>
                            <td><h2><a name="openIssues"></a>Unresolved Issues (<%= unresolvedIssues.size() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
					<% if (splitIssuesSection)
					{
					%>
<!-- Overview Table if threshold is exceeded -->
                       <tr>
                            <td>
                            <% 
                               i = 0;
                            %>
                                <table class="techTable" width="100%" id="unresolvedIssues">
                                	<thead>
	                                    <tr>
	                                        <th>Type</th>
	                                        <th>Severity</th>
	                                        <th>Category</th>
	                                        <th>Issue Count</th>
	                                        <th><!-- Details --></th>
	                                    </tr>
                                    </thead>
                                    <%                                    
                                    for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.element.IIssueId, List<com.hello2morrow.sonargraph.core.model.element.Issue>> issueEntry : unresolvedIssuesGroupedByIssueId)
                                    {
                                    	com.hello2morrow.sonargraph.core.model.element.IIssueId id = issueEntry.getKey();
                                    	out.println("<tr>");
                                        out.println("<td>");
                                        out.println(id.getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(id.getSeverity().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(id.getCategory().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issueEntry.getValue().size());
                                        out.println("</td>");
                                        out.println("<td>");
                                        String fileName = issueIdToIssueFilenameMap.get(id);
                                        boolean truncated = maxNumberOfIssuesPerTypeOnDetailPage > 0 && issueEntry.getValue().size() > maxNumberOfIssuesPerTypeOnDetailPage;
                                        out.println("<a href=\"./" + fileName + "\" target=\"" + fileName + "\">Open" + (truncated ? " Truncated" : "") + " Detailed Report</a>");
                                        out.println("</td>");
                                        out.println("</tr>");
                                        i++;
                                    }
                                    %>
                                </table>                                	
                            	<script>
                            		var rowCount = <%=i%>;
                            		var rowCounts = [25, 50];
                            		if (rowCount > 50)
                            		{
                            			rowCounts = [25, 50, rowCount];
                            		}
                            		
                            		var enablePaging = rowCount > 25;
                            		
						    		var filtersConfig = {
										base_path: 'tablefilter/',
						        		extensions:[{
							          		name: 'sort'
						        		}],
										alternate_rows: true,
										rows_counter: true,
						            	rows_counter_text: 'Issues: ',
						            	btn_reset: true,
						            	status_bar: true,
						            	loader: true,
										mark_active_columns: true,
										highlight_keywords: true,
										paging: enablePaging,
								        results_per_page: ['Issues/Page: ', rowCounts],
								       	col_widths: ['350px', '100px', '80px', '80px', '350px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('unresolvedIssues', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                        <%					
                    	if (unresolvedIssues.size() == 0)
                        {
                            out.println("<tr>");
                            out.println("<td>No unresolved issues</td>");
                            out.println("</tr>");
                        }
                        %>  
					<%
					} 
					else
					{
					%>
<!-- All unresolved issues within the report if number of issues is below threshold -->
                     <tr>
                            <td>
                            <% 
                               i = 0;
                            %>
                                <table class="techTable" width="100%" id="unresolvedIssues">
                                	<thead>
	                                    <tr>
	                                        <th>Type</th>
	                                        <th>Description</th>
	                                        <th>Severity</th>
	                                        <th>Category</th>
	                                        <th>Element</th>
	                                        <th>To Element</th>
	                                        <th>Provider</th>
	                                    </tr>
                                    </thead>
                                    <%                                    
                                    for (com.hello2morrow.sonargraph.core.model.element.Issue issue : report.getUnresolvedIssues())
                                    {
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(issue.getName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getId().getSeverity().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getId().getCategory().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getElementOrFrom(issue));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getTo(issue));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getProvider().getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                        i++;
                                    }
                                    %>
                                </table>
                            	<script>
                            		var rowCount = <%=i%>;
                            		var rowCounts = [25, 50];
                            		if (rowCount > 50)
                            		{
                            			rowCounts = [25, 50, rowCount];
                            		}
                            		
                            		var enablePaging = rowCount > 25;
                            		
						    		var filtersConfig = {
										base_path: 'tablefilter/',
						        		extensions:[{
							          		name: 'sort'
						        		}],
										alternate_rows: true,
										rows_counter: true,
						            	rows_counter_text: 'Issues: ',
						            	btn_reset: true,
						            	status_bar: true,
						            	loader: true,
										mark_active_columns: true,
										highlight_keywords: true,
										paging: enablePaging,
								        results_per_page: ['Issues/Page: ', rowCounts],
								        col_widths: ['100px', '350px', '80px', '80px', '350px', '350px', '100px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('unresolvedIssues', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                        <%					
                    	if (unresolvedIssues.size() == 0)
                        {
                            out.println("<tr>");
                            out.println("<td>No unresolved issues</td>");
                            out.println("</tr>");
                        }
                        %> 
<!-- Unresolved Cycle Groups -->
                        <tr>
                            <td><h2><a name="cycleGroups"></a>Unresolved Cycle Groups (<%= report.getNumberOfUnresolvedCycleGroups() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <% 
                                for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IAnalyzerId, java.util.List<com.hello2morrow.sonargraph.core.model.analysis.CycleGroupIssue>> entry : report.getUnresolvedCycleIssues().entrySet())
                                {
                                    i = 0;
                                %>
                                <h3><%= entry.getKey().getPresentationName() %> (<%= entry.getValue().size() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h3>
                                <table class="techTable" width="100%" id="<%=entry.getKey().getStandardName()%>">
                                	<thead>
	                                    <tr>
	                                        <th>Name</th>
	                                        <th>Scope</th>
	                                        <th>Size</th>
	                                        <th>Involved Elements</th>
	                                    </tr>
	                                 </thead>
                                    <%
                                    for (com.hello2morrow.sonargraph.core.model.analysis.CycleGroupIssue nextCycleGroupIssue : entry.getValue())
                                    {
                                        com.hello2morrow.sonargraph.core.model.analysis.AnalyzerCycleGroup group = ((com.hello2morrow.sonargraph.core.model.analysis.AnalyzerCycleGroup) nextCycleGroupIssue.getAffectedElement())
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(nextCycleGroupIssue.getAffectedElement().getName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(group.getScope().getImageResourceName() + ": " + group.getScope().getPresentationName(true));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(group.getNumberOfCyclicElements());
                                        out.println("</td>");
                                        out.println("<td>");

                                        for (com.hello2morrow.sonargraph.core.model.element.NamedElement next : group.getCyclicNamedElements())
                                        {
                                            out.println(next.getPresentationName(false) + " <br/>");
                                        }    
                                        i++;
                                        out.println("</td>");
                                        out.println("</tr>");
                                    }
                                    %>
                                	</table>
                                    <script>
                                    	var rowCount = <%=entry.getValue().size()%>;
                                		var rowCounts = [25, 50];
                                		if (rowCount > 50)
                                		{
                                			rowCounts = [25, 50, rowCount];
                                		}
                                		
                                		var enablePaging = rowCount > 25;
                                		
							    		var filtersConfig = {
											base_path: 'tablefilter/',
							        		extensions:[{
								          		name: 'sort',
								          		types: ['string', 'string', 'number', 'string']								          		
							        		}],
											alternate_rows: true,
											rows_counter: true,
							            	rows_counter_text: 'Cycle Groups: ',
							            	btn_reset: true,
							            	status_bar: true,
							            	loader: true,
											mark_active_columns: true,
											highlight_keywords: true,
											paging: enablePaging,
									        results_per_page: ['Cycle Groups/Page: ', rowCounts],
									       	col_widths: ['120px', '150px', '50px', '60%'],
							        		themes: [{ name: 'default' }]
									    };
										var tf = new TableFilter('<%=entry.getKey().getStandardName()%>', filtersConfig);
										tf.init();
                                    </script>
                                    <%
                                    if (entry.getValue().size() == 0)
                                    {
                                       out.println("<br/>No " + entry.getKey().getPresentationName() + "<br/>");
                                    }
                                    %>
                                <%
                                }
                                %>
                            </td>
                        </tr>
                        
<!-- Unresolved Duplicate Blocks -->                        
                        <tr>
                            <td><h2><a name="duplicateBlocks"></a>Unresolved Duplicate Blocks <% 
                            if (isDuplicateCodeEnabled) 
                            { 
                                out.println("(" + report.getUnresolvedDuplicateIssues().size() + ")")
                            }%> <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" id="duplicates" width="100%">
                                    <thead>
	                                    <tr>
	                                        <th>Name</th>
	                                        <th>File</th>
	                                        <th>Line Range</th>
	                                        <th>Block Length (Lines)</th>
	                                        <th>Tolerance (Lines)</th>
	                                    </tr>
	                                </thead>
                                    <% 
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockIssue duplicateIssue : report.getUnresolvedDuplicateIssues())
                                    {
                                        com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlock duplicate = (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlock) duplicateIssue.getAffectedElement();
                                        for (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockOccurrence occurrence : duplicate.getChildren(com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockOccurrence.class))
                                        {
	                                        i++;
                                            out.println("<tr>");
                                            out.println("<td>");
	                                        out.println(duplicate.getName());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getSourceFile().getPresentationName(false));
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getLineRange());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getBlockSize());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getToleranceAsInt());
                                            out.println("</td>");
                                            out.println("</tr>");
                                        }
                                    }
                                    %>
                                </table>
								<script>
                            		var rowCount = <%=i%>;
                            		var rowCounts = [25, 50];
                            		if (rowCount > 50)
                            		{
                            			rowCounts = [25, 50, rowCount];
                            		}
                            		
                            		var enablePaging = rowCount > 25;
                            		
						    		var filtersConfig = {
										base_path: 'tablefilter/',
						        		extensions:[{
							          		name: 'sort',
							          		types: ['string', 'string', 'string', 'number', 'number']								          		
						        		}],
										alternate_rows: true,
										rows_counter: true,
						            	rows_counter_text: 'Duplicates: ',
						            	btn_reset: true,
						            	status_bar: true,
						            	loader: true,
										mark_active_columns: true,
										highlight_keywords: true,
										paging: enablePaging,
								        results_per_page: ['Duplicates/Page: ', rowCounts],
								       	col_widths: ['80px', '60%', '50px', '50px', '50px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('duplicates', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                        <%
                        if (i == 0)
                        {
                            out.println("<tr>");
                            if (isDuplicateCodeEnabled)
                            {
                                out.println("<td>No duplicate blocks</td>");
                            }
                            else
                            {
                                out.println("<td><font color=\"red\">Duplicate code not licensed</font></td>");
                            }
                            out.println("</tr>");
                        }
                        %> 
                   <%
                   }
                   %>
<!-- Resolutions -->    
                  <%  
                  if (!isVirtualModelsEnabled) 
                  { 
                  %>   
                    <tr>
                        <td><h2><a name="resolutions"></a>Resolutions  <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                    </tr>
                  <%
                  } 
                  else
                  {
                  %>
                    <tr>
                        <td><h2><a name="resolutions"></a>Resolutions (<%= resolutions.size() %>) of Virtual Model "<%= report.currentVirtualModel %>" <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                    </tr>
                    <%
                    }
                    %>
                    <%
                    if(splitResolutionSection)
                    {
                   	%>
                   		<tr>
                            <td>
                                <table width="100%" id="resolutions">
                                   	<thead>
	                                    <tr>
	                                        <th>Issue Type</th>
	                                        <th>Severity</th>
	                                        <th>Category</th>
	                                        <th>Resolution Count</th>
	                                        <th><!-- Details --></th>
	                                    </tr>
                                    </thead>
                                    <% 
                                    i = 0;
                                    for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.element.IIssueId, List<com.hello2morrow.sonargraph.core.model.resolution.Resolution>> resolutionEntry : resolutionsGroupedByIssueId)
                                    {
                                        i++;
                                        com.hello2morrow.sonargraph.core.model.element.IIssueId id = resolutionEntry.getKey();
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(id.getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(id.getSeverity().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(id.getCategory().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolutionEntry.getValue().size());
                                        out.println("</td>");
                                        out.println("<td>");
                                        String fileName = issueIdToResolutionFilenameMap.get(id);
                                        boolean truncated = maxNumberOfIssuesPerTypeOnDetailPage > 0 && resolutionEntry.getValue().size() > maxNumberOfIssuesPerTypeOnDetailPage;
                                        out.println("<a href=\"./" + fileName + "\" target=\"" + fileName + "\">Open" + (truncated ? " Truncated" : "") + " Detailed Report</a>");
                                        out.println("</td>");
                                        out.println("</tr>");
                                    }
                                    %>
                                </table>
                            	<script>
                            		var rowCount = <%=i%>;
                            		var rowCounts = [25, 50];
                            		if (rowCount > 50)
                            		{
                            			rowCounts = [25, 50, rowCount];
                            		}
                            		
                            		var enablePaging = rowCount > 25;
                            		
						    		var filtersConfig = {
										base_path: 'tablefilter/',
						        		extensions:[{
							          		name: 'sort',
							          		types: ['string', 'string', 'string', 'string', 'string', 'number', 'string', 'string']								          		
						        		}],
										alternate_rows: true,
										rows_counter: true,
						            	rows_counter_text: 'Resolutions: ',
						            	btn_reset: true,
						            	status_bar: true,
						            	loader: true,
										mark_active_columns: true,
										highlight_keywords: true,
										paging: enablePaging,
								        results_per_page: ['Resolutions/Page: ', rowCounts],
								       	col_widths: ['350px', '100px', '80px', '80px', '350px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('resolutions', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                   	<%
                    }
                    else
                    {
                    %>
                        <tr>
                            <td>
                                <table width="100%" id="resolutions">
                                   	<thead>
	                                    <tr>
	                                        <th width="80">Resolution Type</th>
	                                        <th width="120">Issue Type</th>
	                                        <th width="250">Description</th>
	                                        <th width="250">Information</th>
	                                        <th width="70">Date</th>
	                                        <th width="70">Matched</th>
	                                        <th width="70">Priority</th>
	                                        <th width="70">Assignee</th>
	                                    </tr>
                                    </thead>
                                    <% 
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.resolution.Resolution resolution : report.getResolutions())
                                    {
                                        i++;
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(resolution.getPresentationKind());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getIssueType(resolution));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getInformation());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getDate(resolution.getDate()));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getMatchingElementsCount());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getPriority().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getAssignee());
                                        out.println("</td>");
                                        out.println("</tr>");
                                    }
                                    %>
                                </table>
                                
                            	<script>
                            		var rowCount = <%=i%>;
                            		var rowCounts = [25, 50];
                            		if (rowCount > 50)
                            		{
                            			rowCounts = [25, 50, rowCount];
                            		}
                            		
                            		var enablePaging = rowCount > 25;
                            		
						    		var filtersConfig = {
										base_path: 'tablefilter/',
						        		extensions:[{
							          		name: 'sort',
							          		types: ['string', 'string', 'string', 'string', 'string', 'number', 'string', 'string']								          		
						        		}],
										alternate_rows: true,
										rows_counter: true,
						            	rows_counter_text: 'Resolutions: ',
						            	btn_reset: true,
						            	status_bar: true,
						            	loader: true,
										mark_active_columns: true,
										highlight_keywords: true,
										paging: enablePaging,
								        results_per_page: ['Resolutions/Page: ', rowCounts],
								       	col_widths: ['80px', '120px', '250px', '250px', '70px', '70px', '70px', '70px'],
						        		themes: [{ name: 'default' }]
								    };
									var tf = new TableFilter('resolutions', filtersConfig);
									tf.init();
								</script>
                            </td>
                        </tr>
                        <%
                        }
                        %>              
                        <%
 						out.println("<tr>");
                        if (!isVirtualModelsEnabled)
                        {
                            out.println("<td><font color=\"red\">Virtual models not licensed</font></td>");
                        }
                        else if (i == 0)
                        {
                            out.println("<td>No resolutions</td>");
                        }
                        out.println("</tr>");
                    %>
<!-- Element Metrics -->                                        
                        <tr>
                            <td><h2><a name="elementMetrics"></a>Element Level Metrics <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, java.util.Map<
                               com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.MetricRow>>>> entry : metricValueRows.entrySet())
                        {
                        %>
                            <tr>
                                <td>
                                    <h3><a name="elementMetrics_<%=entry.getKey().getStandardName()%>"></a><%=entry.getKey().getPresentationName()%> Level Metrics <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h3>
                                </td>
                            </tr>
                            <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.MetricRow>>> nextCategory : entry.getValue().entrySet())
                               {
                            %>
                            <tr>
                                <td>        
                                    <strong>Metric Category: <%= nextCategory.getKey().getPresentationName()%></strong> (Note: Only showing the top <%= maxMetricValueRowCountPerMetric %> values per metric.)<br/>
                                    <table class="techTable" id="elementMetrics_<%=entry.getKey().getStandardName()%>_<%=nextCategory.getKey().getStandardName()%>">
	                                    <thead>
	                                        <tr>
	                                            <th>Metric</th>
	                                            <th><%=entry.getKey().getPresentationName()%></th>
	                                            <th>Value</th>
	                                        </tr>
				                        </thead>
                                        <%
                                        i = 0;
                                        String currentMetric = null;
                                        for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, java.util.Set<com.hello2morrow.sonargraph.core.model.report.MetricRow>> rowMap : nextCategory.getValue().entrySet())
                                        {
                                            for (com.hello2morrow.sonargraph.core.model.report.MetricRow row : rowMap.getValue())
                                            {  
                                                out.println("<tr>");
                                                out.println("<td>");
                                                if (!row.getMetricName().equals(currentMetric))
                                                {
                                                    out.println(row.getMetricName());
                                                }
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(row.getElementName());
                                                out.println("</td>");
                                                out.println("<td>");
                                                if (row.isFloat())
                                                {
                                                    out.println(String.format("%.2f", row.getMetricValue()));
                                                }
                                                else 
                                                {
                                                    out.println(row.getMetricValue());
                                                }
                                                out.println("</td>");
                                                out.println("</tr>");
                                                i++;
                                                currentMetric = row.getMetricName();
                                            }
                                        } 
                                        %>
                                    </table>
                                    <script>
	                            		var filtersConfig = {
											base_path: 'tablefilter/',
							        		alternate_rows: true,
							        		grid: false,
										    col_widths: ['250px', '80%', '50px'],
							        		themes: [{ name: 'default' }]
									    };
										var tf = new TableFilter('elementMetrics_<%=entry.getKey().getStandardName()%>_<%=nextCategory.getKey().getStandardName()%>', filtersConfig);
										tf.init();
									</script>
                                    <br/>
                                    <br/>
                                </td>
                            </tr>
                        <%
                            }
                        }
                        %>
<!-- Metric Information -->     
                        <tr>
                            <td><h2><a name="metricInfos"></a>Metric Info <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="100%" id="metricInfos">
                                    <thead>
	                                    <tr>
	                                        <th>Name</th>
	                                        <th>Description</th>
	                                        <th>Category</th>
	                                        <th>Provider</th>
	                                    </tr>
                                    </thead>
                                    <%
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.analysis.IMetricId metric : report.getMetricIds())
                                    {
                                        out.println("<tr>");
                                        out.println("<td>");
                                        out.println(metric.getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(metric.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        java.util.List<String> categories = new java.util.ArrayList<String>();
                                        for (com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory next : metric.getCategories())
                                        {
                                            categories.add(next.getPresentationName());
                                        }
                                        out.println(com.hello2morrow.foundation.utilities.StringUtility.concat(categories, ", "));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(metric.getProvider().getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                        i++;
                                    } 
                                    %>
                                </table>
                                <%
                            	if (i > 0)
                            	{
                            	%>
                                	<script>
                                		var filtersConfig = {
											base_path: 'tablefilter/',
							        		extensions:[{
								          		name: 'sort',
								          		types: ['string', 'string', 'string', 'string']								          		
							        		}],
											alternate_rows: true,
											rows_counter: true,
							            	rows_counter_text: 'Metrics: ',
							            	btn_reset: true,
							            	status_bar: true,
							            	loader: true,
											mark_active_columns: true,
											highlight_keywords: true,
									       	col_widths: ['250px', '50%', '180px', '250px'],
							        		themes: [{ name: 'default' }]
									    };
										var tf = new TableFilter('metricInfos', filtersConfig);
										tf.init();
									</script>
                            	<%
                            	}
                            	%>
                            </td>
                        </tr>                                                                                                                        
                    </table>
                </td>
                
    <!-- end of real content -->
            </tr>
        </table>
    </body>
</html>